#ifndef _FBAB_H
#define _FBAB_H

#include <stdio.h>
#include <stdlib.h>
#include <assert.h>

#include "matrix.h"

typedef struct {
    FILE * file; // Fichier lu ou crit
    unsigned char tampon; // Tampon de 8 bits,  remplir avant criture
    signed char position; // Position dans le tampon
} FBAB;

FBAB * fbab_open(char * filename, char * flags);
void fbab_close(FBAB * f);
void fbab_flush(FBAB * f);

inline int fbab_writebit(unsigned char bit, FBAB * f);
int fbab_write8(unsigned char data, FBAB * f);
int fbab_writevector(matrix * v, FBAB * f);
int fbab_writetab(unsigned char * tab, int size, FBAB * f);

inline int fbab_readbit(unsigned char * bit, FBAB * f);
int fbab_read8(unsigned char * data, FBAB * f);

#endif /* _FBAB_H */
